curl --request PUT \
--url https://registry.{region}.basaltic.sh/v1/repositories/{repository_id}/policy \
--header 'Authorization: Bearer <token>' \
--header 'Content-Type: application/json' \
--data '
{
"document": {
"version": "2024-01-01",
"statements": [
{
"principals": [
"crn:iam::other-account:account/other-account"
],
"actions": [
"registry:BatchGetImage",
"registry:GetDownloadUrlForLayer",
"registry:ListImages"
],
"resources": [
"*"
],
"sid": "<string>",
"conditions": [
{
"operator": "equals",
"key": "basalt:ResourceTag/env",
"values": [
"prod"
]
}
]
}
]
}
}
'import requests
url = "https://registry.{region}.basaltic.sh/v1/repositories/{repository_id}/policy"
payload = { "document": {
"version": "2024-01-01",
"statements": [
{
"principals": ["crn:iam::other-account:account/other-account"],
"actions": ["registry:BatchGetImage", "registry:GetDownloadUrlForLayer", "registry:ListImages"],
"resources": ["*"],
"sid": "<string>",
"conditions": [
{
"operator": "equals",
"key": "basalt:ResourceTag/env",
"values": ["prod"]
}
]
}
]
} }
headers = {
"Authorization": "Bearer <token>",
"Content-Type": "application/json"
}
response = requests.put(url, json=payload, headers=headers)
print(response.text)const options = {
method: 'PUT',
headers: {Authorization: 'Bearer <token>', 'Content-Type': 'application/json'},
body: JSON.stringify({
document: {
version: '2024-01-01',
statements: [
{
principals: ['crn:iam::other-account:account/other-account'],
actions: [
'registry:BatchGetImage',
'registry:GetDownloadUrlForLayer',
'registry:ListImages'
],
resources: ['*'],
sid: '<string>',
conditions: [{operator: 'equals', key: 'basalt:ResourceTag/env', values: ['prod']}]
}
]
}
})
};
fetch('https://registry.{region}.basaltic.sh/v1/repositories/{repository_id}/policy', options)
.then(res => res.json())
.then(res => console.log(res))
.catch(err => console.error(err));<?php
$curl = curl_init();
curl_setopt_array($curl, [
CURLOPT_URL => "https://registry.{region}.basaltic.sh/v1/repositories/{repository_id}/policy",
CURLOPT_RETURNTRANSFER => true,
CURLOPT_ENCODING => "",
CURLOPT_MAXREDIRS => 10,
CURLOPT_TIMEOUT => 30,
CURLOPT_HTTP_VERSION => CURL_HTTP_VERSION_1_1,
CURLOPT_CUSTOMREQUEST => "PUT",
CURLOPT_POSTFIELDS => json_encode([
'document' => [
'version' => '2024-01-01',
'statements' => [
[
'principals' => [
'crn:iam::other-account:account/other-account'
],
'actions' => [
'registry:BatchGetImage',
'registry:GetDownloadUrlForLayer',
'registry:ListImages'
],
'resources' => [
'*'
],
'sid' => '<string>',
'conditions' => [
[
'operator' => 'equals',
'key' => 'basalt:ResourceTag/env',
'values' => [
'prod'
]
]
]
]
]
]
]),
CURLOPT_HTTPHEADER => [
"Authorization: Bearer <token>",
"Content-Type: application/json"
],
]);
$response = curl_exec($curl);
$err = curl_error($curl);
curl_close($curl);
if ($err) {
echo "cURL Error #:" . $err;
} else {
echo $response;
}package main
import (
"fmt"
"strings"
"net/http"
"io"
)
func main() {
url := "https://registry.{region}.basaltic.sh/v1/repositories/{repository_id}/policy"
payload := strings.NewReader("{\n \"document\": {\n \"version\": \"2024-01-01\",\n \"statements\": [\n {\n \"principals\": [\n \"crn:iam::other-account:account/other-account\"\n ],\n \"actions\": [\n \"registry:BatchGetImage\",\n \"registry:GetDownloadUrlForLayer\",\n \"registry:ListImages\"\n ],\n \"resources\": [\n \"*\"\n ],\n \"sid\": \"<string>\",\n \"conditions\": [\n {\n \"operator\": \"equals\",\n \"key\": \"basalt:ResourceTag/env\",\n \"values\": [\n \"prod\"\n ]\n }\n ]\n }\n ]\n }\n}")
req, _ := http.NewRequest("PUT", url, payload)
req.Header.Add("Authorization", "Bearer <token>")
req.Header.Add("Content-Type", "application/json")
res, _ := http.DefaultClient.Do(req)
defer res.Body.Close()
body, _ := io.ReadAll(res.Body)
fmt.Println(string(body))
}HttpResponse<String> response = Unirest.put("https://registry.{region}.basaltic.sh/v1/repositories/{repository_id}/policy")
.header("Authorization", "Bearer <token>")
.header("Content-Type", "application/json")
.body("{\n \"document\": {\n \"version\": \"2024-01-01\",\n \"statements\": [\n {\n \"principals\": [\n \"crn:iam::other-account:account/other-account\"\n ],\n \"actions\": [\n \"registry:BatchGetImage\",\n \"registry:GetDownloadUrlForLayer\",\n \"registry:ListImages\"\n ],\n \"resources\": [\n \"*\"\n ],\n \"sid\": \"<string>\",\n \"conditions\": [\n {\n \"operator\": \"equals\",\n \"key\": \"basalt:ResourceTag/env\",\n \"values\": [\n \"prod\"\n ]\n }\n ]\n }\n ]\n }\n}")
.asString();require 'uri'
require 'net/http'
url = URI("https://registry.{region}.basaltic.sh/v1/repositories/{repository_id}/policy")
http = Net::HTTP.new(url.host, url.port)
http.use_ssl = true
request = Net::HTTP::Put.new(url)
request["Authorization"] = 'Bearer <token>'
request["Content-Type"] = 'application/json'
request.body = "{\n \"document\": {\n \"version\": \"2024-01-01\",\n \"statements\": [\n {\n \"principals\": [\n \"crn:iam::other-account:account/other-account\"\n ],\n \"actions\": [\n \"registry:BatchGetImage\",\n \"registry:GetDownloadUrlForLayer\",\n \"registry:ListImages\"\n ],\n \"resources\": [\n \"*\"\n ],\n \"sid\": \"<string>\",\n \"conditions\": [\n {\n \"operator\": \"equals\",\n \"key\": \"basalt:ResourceTag/env\",\n \"values\": [\n \"prod\"\n ]\n }\n ]\n }\n ]\n }\n}"
response = http.request(request)
puts response.read_body{
"policy": {
"document": {
"version": "2024-01-01",
"statements": [
{
"effect": "allow",
"principals": [
"crn:iam::other-account:account/other-account"
],
"actions": [
"registry:BatchGetImage",
"registry:GetDownloadUrlForLayer",
"registry:ListImages"
],
"resources": [
"*"
],
"sid": "<string>",
"conditions": [
{
"operator": "equals",
"key": "basalt:ResourceTag/env",
"values": [
"prod"
],
"set_operator": "for_all_values"
}
]
}
]
},
"updated_at": "2023-11-07T05:31:56Z"
}
}{
"error": {
"code": "INVALID_INPUT",
"message": "Invalid request parameters",
"request_id": "550e8400-e29b-41d4-a716-446655440000"
}
}{
"error": {
"code": "UNAUTHORIZED",
"message": "Authentication required",
"request_id": "550e8400-e29b-41d4-a716-446655440000"
}
}{
"error": {
"code": "ACCESS_DENIED",
"message": "You don't have permission to perform this action",
"request_id": "550e8400-e29b-41d4-a716-446655440000"
}
}{
"error": {
"code": "NOT_FOUND",
"message": "Resource not found",
"request_id": "550e8400-e29b-41d4-a716-446655440000"
}
}Definir política do repositório
Concede acesso externo à conta; principal * permite pulls públicos. A política é substituída integralmente. Cada declaração deve identificar principal, usar ações registry: e apontar para o CRN deste repositório ou *. not_actions e not_resources são rejeitados. Acesso entre contas também exige autorização da política IAM do chamador; a política do recurso não amplia as permissões da organização.
curl --request PUT \
--url https://registry.{region}.basaltic.sh/v1/repositories/{repository_id}/policy \
--header 'Authorization: Bearer <token>' \
--header 'Content-Type: application/json' \
--data '
{
"document": {
"version": "2024-01-01",
"statements": [
{
"principals": [
"crn:iam::other-account:account/other-account"
],
"actions": [
"registry:BatchGetImage",
"registry:GetDownloadUrlForLayer",
"registry:ListImages"
],
"resources": [
"*"
],
"sid": "<string>",
"conditions": [
{
"operator": "equals",
"key": "basalt:ResourceTag/env",
"values": [
"prod"
]
}
]
}
]
}
}
'import requests
url = "https://registry.{region}.basaltic.sh/v1/repositories/{repository_id}/policy"
payload = { "document": {
"version": "2024-01-01",
"statements": [
{
"principals": ["crn:iam::other-account:account/other-account"],
"actions": ["registry:BatchGetImage", "registry:GetDownloadUrlForLayer", "registry:ListImages"],
"resources": ["*"],
"sid": "<string>",
"conditions": [
{
"operator": "equals",
"key": "basalt:ResourceTag/env",
"values": ["prod"]
}
]
}
]
} }
headers = {
"Authorization": "Bearer <token>",
"Content-Type": "application/json"
}
response = requests.put(url, json=payload, headers=headers)
print(response.text)const options = {
method: 'PUT',
headers: {Authorization: 'Bearer <token>', 'Content-Type': 'application/json'},
body: JSON.stringify({
document: {
version: '2024-01-01',
statements: [
{
principals: ['crn:iam::other-account:account/other-account'],
actions: [
'registry:BatchGetImage',
'registry:GetDownloadUrlForLayer',
'registry:ListImages'
],
resources: ['*'],
sid: '<string>',
conditions: [{operator: 'equals', key: 'basalt:ResourceTag/env', values: ['prod']}]
}
]
}
})
};
fetch('https://registry.{region}.basaltic.sh/v1/repositories/{repository_id}/policy', options)
.then(res => res.json())
.then(res => console.log(res))
.catch(err => console.error(err));<?php
$curl = curl_init();
curl_setopt_array($curl, [
CURLOPT_URL => "https://registry.{region}.basaltic.sh/v1/repositories/{repository_id}/policy",
CURLOPT_RETURNTRANSFER => true,
CURLOPT_ENCODING => "",
CURLOPT_MAXREDIRS => 10,
CURLOPT_TIMEOUT => 30,
CURLOPT_HTTP_VERSION => CURL_HTTP_VERSION_1_1,
CURLOPT_CUSTOMREQUEST => "PUT",
CURLOPT_POSTFIELDS => json_encode([
'document' => [
'version' => '2024-01-01',
'statements' => [
[
'principals' => [
'crn:iam::other-account:account/other-account'
],
'actions' => [
'registry:BatchGetImage',
'registry:GetDownloadUrlForLayer',
'registry:ListImages'
],
'resources' => [
'*'
],
'sid' => '<string>',
'conditions' => [
[
'operator' => 'equals',
'key' => 'basalt:ResourceTag/env',
'values' => [
'prod'
]
]
]
]
]
]
]),
CURLOPT_HTTPHEADER => [
"Authorization: Bearer <token>",
"Content-Type: application/json"
],
]);
$response = curl_exec($curl);
$err = curl_error($curl);
curl_close($curl);
if ($err) {
echo "cURL Error #:" . $err;
} else {
echo $response;
}package main
import (
"fmt"
"strings"
"net/http"
"io"
)
func main() {
url := "https://registry.{region}.basaltic.sh/v1/repositories/{repository_id}/policy"
payload := strings.NewReader("{\n \"document\": {\n \"version\": \"2024-01-01\",\n \"statements\": [\n {\n \"principals\": [\n \"crn:iam::other-account:account/other-account\"\n ],\n \"actions\": [\n \"registry:BatchGetImage\",\n \"registry:GetDownloadUrlForLayer\",\n \"registry:ListImages\"\n ],\n \"resources\": [\n \"*\"\n ],\n \"sid\": \"<string>\",\n \"conditions\": [\n {\n \"operator\": \"equals\",\n \"key\": \"basalt:ResourceTag/env\",\n \"values\": [\n \"prod\"\n ]\n }\n ]\n }\n ]\n }\n}")
req, _ := http.NewRequest("PUT", url, payload)
req.Header.Add("Authorization", "Bearer <token>")
req.Header.Add("Content-Type", "application/json")
res, _ := http.DefaultClient.Do(req)
defer res.Body.Close()
body, _ := io.ReadAll(res.Body)
fmt.Println(string(body))
}HttpResponse<String> response = Unirest.put("https://registry.{region}.basaltic.sh/v1/repositories/{repository_id}/policy")
.header("Authorization", "Bearer <token>")
.header("Content-Type", "application/json")
.body("{\n \"document\": {\n \"version\": \"2024-01-01\",\n \"statements\": [\n {\n \"principals\": [\n \"crn:iam::other-account:account/other-account\"\n ],\n \"actions\": [\n \"registry:BatchGetImage\",\n \"registry:GetDownloadUrlForLayer\",\n \"registry:ListImages\"\n ],\n \"resources\": [\n \"*\"\n ],\n \"sid\": \"<string>\",\n \"conditions\": [\n {\n \"operator\": \"equals\",\n \"key\": \"basalt:ResourceTag/env\",\n \"values\": [\n \"prod\"\n ]\n }\n ]\n }\n ]\n }\n}")
.asString();require 'uri'
require 'net/http'
url = URI("https://registry.{region}.basaltic.sh/v1/repositories/{repository_id}/policy")
http = Net::HTTP.new(url.host, url.port)
http.use_ssl = true
request = Net::HTTP::Put.new(url)
request["Authorization"] = 'Bearer <token>'
request["Content-Type"] = 'application/json'
request.body = "{\n \"document\": {\n \"version\": \"2024-01-01\",\n \"statements\": [\n {\n \"principals\": [\n \"crn:iam::other-account:account/other-account\"\n ],\n \"actions\": [\n \"registry:BatchGetImage\",\n \"registry:GetDownloadUrlForLayer\",\n \"registry:ListImages\"\n ],\n \"resources\": [\n \"*\"\n ],\n \"sid\": \"<string>\",\n \"conditions\": [\n {\n \"operator\": \"equals\",\n \"key\": \"basalt:ResourceTag/env\",\n \"values\": [\n \"prod\"\n ]\n }\n ]\n }\n ]\n }\n}"
response = http.request(request)
puts response.read_body{
"policy": {
"document": {
"version": "2024-01-01",
"statements": [
{
"effect": "allow",
"principals": [
"crn:iam::other-account:account/other-account"
],
"actions": [
"registry:BatchGetImage",
"registry:GetDownloadUrlForLayer",
"registry:ListImages"
],
"resources": [
"*"
],
"sid": "<string>",
"conditions": [
{
"operator": "equals",
"key": "basalt:ResourceTag/env",
"values": [
"prod"
],
"set_operator": "for_all_values"
}
]
}
]
},
"updated_at": "2023-11-07T05:31:56Z"
}
}{
"error": {
"code": "INVALID_INPUT",
"message": "Invalid request parameters",
"request_id": "550e8400-e29b-41d4-a716-446655440000"
}
}{
"error": {
"code": "UNAUTHORIZED",
"message": "Authentication required",
"request_id": "550e8400-e29b-41d4-a716-446655440000"
}
}{
"error": {
"code": "ACCESS_DENIED",
"message": "You don't have permission to perform this action",
"request_id": "550e8400-e29b-41d4-a716-446655440000"
}
}{
"error": {
"code": "NOT_FOUND",
"message": "Resource not found",
"request_id": "550e8400-e29b-41d4-a716-446655440000"
}
}registry:SetRepositoryPolicy. Veja REGISTRY permissões para a lista completa, o escopo de cada ação e um exemplo de política.Autorizações
Um token bearer OAuth 2.0, enviado como Authorization: Bearer <token>. Esta é a forma recomendada de autenticação.
Obtenha o token trocando o par de chaves de acesso de uma conta de serviço em POST /v1/oauth/token com grant_type=client_credentials. Esse é o fluxo padrão de credenciais de cliente; bibliotecas compatíveis com OAuth podem obter e renovar o token para você.
curl -s -u "$KEY_ID:$SECRET" -d grant_type=client_credentials \
https://iam.basaltic.sh/v1/oauth/token
Os tokens duram uma hora por padrão. O mesmo par de chaves de acesso também serve como credencial AWS SigV4 para o endpoint de objetos compatível com S3, que aceita somente esse método de autenticação.
Parâmetros de caminho
"a1b2c3d4-5e6f-4a7b-8c9d-0e1f2a3b4c5d"
Corpo
Política de recurso. Cada declaração precisa identificar um principal; o documento está associado ao recurso e não pode inferir quem recebe acesso.
Show child attributes
Show child attributes
Resposta
Política armazenada.
Show child attributes
Show child attributes

